#ifndef kernel_h
#define kernel_h

#ifndef Private
 #define Private
 #endif
#ifndef Public
 #define Public
 #endif

#ifndef internal
 #ifdef Public
  #undef Public
 #endif
 #define Public extern
#endif

#define ui

#ifdef ui
#define text_mode
#define _welcome
#define _colours
#define _typedefs
#endif

#define name "ManuOS"


#ifdef text_mode

#ifdef _welcome
 Private void print_manuos();
#endif

#ifdef ui

 Public void update_cursor(uint16 position);
 Public void move_cursor(int distance);
 Public int get_cursor_pos();
 Public void set_cursor_pos(int offset);

 Public void cls(int colour);
 Public void scroll_down(uint8 lines);

 Public int outbyte(uint8 c);
 Public int outpix_pos(int c,int colour,int offset);
 Public void _outc_bcg_pos(int colour, int offset);
 Public void mprintf(char *fmt,int colour);


#endif
 Public void init_hardware();
 Public void print_long_(unsigned long a);

 Public uchar in(ushort _port);
 Public void out(ushort _port, uchar _data);

 Public void secDelay(int secs);
 Public void milliDelay(long millisecs);
 Public void microDelay(unsigned long microsecs);

#endif

#ifdef internal
#endif

#endif

